package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;
import jsetlPaperPrograms.usingRIS2020.evaluation.Timer;

public class Es12_RisConstraintSolving {

	public static void risCreation (int cardinality) throws Failure {
		int n = -cardinality;
		if(cardinality % 2 != 0)
			++n;

		Solver solver = new Solver();
		IntLVar x = new IntLVar("x");
		LSet D = new LSet("D");
		Ris R = new Ris(x,D,x.mod(2).eq(0));
		LSet S = LSet.empty();
		for(int i = 0; i < cardinality; ++i)
			S = S.ins(n + 2*i);
		solver.solve(S.eq(R));
		D.output();
		solver.showStore();
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {0,1,5,10,25,50,100};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];

		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				Timer.tick();
				risCreation(c);
				times[i][j] = Timer.tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}