package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;
import jsetlPaperPrograms.usingRIS2020.evaluation.Timer;

import java.util.Random;

public class Es13_RisMin {

	public static LVar minValue(LSet S) throws Failure {
		Solver solver = new Solver();
		IntLVar x = new IntLVar(), m = new IntLVar();
		Ris R = new Ris(x, S, m.le(x));
		solver.add(m.in(S).and(S.subset(R)));
		solver.solve();
		return m;
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {0,1,5,10,25,50,100};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];
		Random random = new Random(42);
		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				IntLSet s = IntLSet.empty();
				for(int k = 0; k < c; ++k)
					s = s.ins(random.nextInt(10000000));
				Timer.tick();
				if(c == 0)
					try {
						minValue(s);
					}catch (Failure failure){
						//nothing to do
					}
				else
					minValue(s);
				times[i][j] = Timer.tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}