package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;

import java.util.Random;

import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.stock;
import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tick;

public class Es14_MapColoring {

	public static void coloring(LSet Rg, LSet Mp, LSet Cl) throws Failure{
		Solver solver = new Solver();
		solver.add(Rg.subset(Cl));
			LSet P = new LSet();
			Ris R = new Ris(P, Mp, P.size(2));
		solver.add(Mp.subset(R));
		solver.solve();
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {0,1,5,10,11,12,13,14};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];
		int seed = 42;
		Random random = new Random(seed);

		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				LVar[] regionsLVar = new LVar[c];
				for(int k = 0; k < c; ++k)
					regionsLVar[k] = new LVar();
				LSet regions = LSet.empty();
				LSet map = LSet.empty();
				for(int k = 0; k < c; ++k) {
					regions = regions.ins(regionsLVar[k]);
					int start = k % 2 == 0 ? 1 : 0;
					for(int kk = start; kk < k; kk+=2)
						map = map.ins(LSet.empty().ins(regionsLVar[k],regionsLVar[kk]));
				}
				tick();
				coloring(regions, map, LSet.empty().ins("red","blue"));
				times[i][j] = stock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}