package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;

import java.util.Random;

import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tick;
import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tock;

public class Es15_PrimeTest {

	public static Boolean isPrime(int n) {
		Solver solver = new Solver();
		if(n <=1)return false;
			IntLVar x = new IntLVar();
			Ris R = new Ris(x, new IntLSet(2, n / 2), new IntLVar(n).mod(x).eq(0));
		return solver.check(R.eq(LSet.empty()));
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {0,1,5,10,25,50,100};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];
		Random random = new Random(42);
		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				IntLSet s = IntLSet.empty();
				for(int k = 0; k < c; ++k)
					s = s.ins(random.nextInt(10000000));
				tick();
				for(int k = 0; k < c; ++k)
					isPrime(k);
				times[i][j] = tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}