package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;

import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tick;
import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tock;

public class Es20_SquaresOfEvens {

	public static void squaresOfEvens (int cardinality) {
		IntLVar x = new IntLVar();
		Ris R = new Ris(x,new IntLSet(1,cardinality),x.mod(2).eq(0),x.mul(x));
		LSet Sqrs = R.expand();
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {0,1,5,10,25,50,100};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];

		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				tick();
				squaresOfEvens(c);
				times[i][j] = tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}