package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;

import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tick;
import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tock;

public class Es21_DomainRestriction {

	public static void squaresOfEvens (int cardinality) throws Failure {
		Solver solver = new Solver();
		LSet S = new LSet("S"), D = new LSet("D");
		LVar x = new LVar(), y = new LVar();
		Ris R = new Ris(x,D,new LPair(x,y).in(S),new LPair(x,y),y);
		for(int i = 0; i < cardinality; ++i)
			solver.add(new LPair(i, 10000*i).in(R));
		solver.solve();
		D.output(); S.output();
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {0,1,5,10,25,50,100};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];

		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				tick();
				squaresOfEvens(c);
				times[i][j] = tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}