package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;

import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tick;
import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tock;

public class Es22_Factorial {

	public static void factorial(int n) throws Failure {
		Solver solver = new Solver();
		LSet fact = new LSet();
		IntLVar x = new IntLVar(), z = new IntLVar();
		Constraint C = x.gt(0).and(new LPair(x.sub(1),z).in(fact));
		Ris R_fact = new Ris(x,new LSet(),C,new LPair(x,z.mul(x)),z);
		solver.add(fact.eq(R_fact.ins(new LPair(0,1))));
		IntLVar f = new IntLVar();
		solver.add(new LPair(n, f).in(fact));
		solver.solve();
		f.output();
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {0,1,5,10,11,12};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];

		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				tick();
				factorial(c);
				times[i][j] = tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}