package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetl.exception.Failure;

import java.util.Random;

import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tick;
import static jsetlPaperPrograms.usingRIS2020.evaluation.Timer.tock;

public class Es23_ReachableNodes {

	public static LSet reachable(LSet N, LRel E, LVar n){
		LVar x = new LVar("x");
		LVar y = new LVar("y");
		LSet R = new LSet();
		Ris R_R = new Ris(x,N,x.eq(n)
				.or(y.in(R).and(new LPair(y,x).in(E))),x,y);
		R.eq(R_R).check();
		return R_R.expand();
	}

	public static void main (String[] args) throws Failure {

		Integer[] cardinalities = {1,5,10,25,50,75,100};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];
		int seed = 42;
		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				IntLSet nodes = new IntLSet(1,c);
				Random random = new Random(seed+i);
				int maxEdges = (int) Math.ceil(((double)c)*c/4);
				System.out.println(maxEdges);
				LRel edges = LRel.empty();
				for(int k = 0; k < c-2; ++k){
					for(int kk = 0; kk < maxEdges/c; ++kk)
						edges = edges.ins(new LPair(k, 1+ k + random.nextInt(c-k-2)));
				}
				nodes.output();
				edges.output();
				tick();
				reachable(nodes, edges, new LVar(1)).output();
				times[i][j] = tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}