package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.LSet;
import jsetl.Solver;
import jsetlPaperPrograms.usingRIS2020.evaluation.Timer;

public class Es7_AllPermutationsLambdaNoConsumer {

		public static void allPermutations(Integer[] A) {
			Solver solver = new Solver();
	    	LSet E = LSet.empty().insAll(A); 
	    	LSet S = LSet.mkSet(A.length);
	    	solver.add(E.eq(S));
	    	solver.forEachSolution(counter -> {System.out.print(counter+")  ");
	    	                                   S.printElems(' ');});
	    }
	    
	    public static void main (String[] args) {

	    	Integer[] cardinalities = {0,1,2,3,4,5,6};
	    	int tries = 22;
	    	Long[][] times = new Long[tries][cardinalities.length];

			for(int i = 0; i < tries; ++i)
	    	for(int j = 0; j < cardinalities.length; ++j){
	    		int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
	    		Integer[] elems = new Integer[c];
	    		for(int k = 0; k < c; ++k)
	    			elems[k] = k + 1;
	    		Timer.tick();
	    		allPermutations(elems);
	    		times[i][j] = Timer.tock();
			}

			System.out.println("-------------------\n------------------");

				for(int j = 0; j < cardinalities.length; ++j){
					int c = cardinalities[j];
					System.out.println("------------------");
					System.out.println("Cardinality: " + c);
					for(int i = 0; i < tries; ++i) {
						System.out.println(times[i][j]);
					}
				}

	    }	    

}
