package jsetlPaperPrograms.usingRIS2020.evaluation.times;

import jsetl.*;
import jsetlPaperPrograms.usingRIS2020.evaluation.Timer;

public class Es9_RisExpand {

	public static void risExpansion (int cardinality) {
		IntLVar x = new IntLVar("x");
		int n = -cardinality/2, m = cardinality/2;
		if(cardinality % 2 == 0)
			--m;

		IntLSet d = new IntLSet(n,m);
		Constraint f = x.mod(2).eq(0);
		Ris ris = new Ris(x,d,f);   // \{x : [-2,2] \(|\) x mod 2 = 0 \(@\) x\}
		LSet S = ris.expand().setName("S");
		S.output();

	}

	public static void main (String[] args) {

		Integer[] cardinalities = {0,1,5,10,25,50,100};
		int tries = 22;
		Long[][] times = new Long[tries][cardinalities.length];

		for(int i = 0; i < tries; ++i)
			for(int j = 0; j < cardinalities.length; ++j){
				int c = cardinalities[j];
				System.out.println("--------------------");
				System.out.println("Cardinality: " + c);
				Timer.tick();
				risExpansion(c);
				times[i][j] = Timer.tock();
			}

		System.out.println("-------------------\n------------------");

		for(int j = 0; j < cardinalities.length; ++j){
			int c = cardinalities[j];
			System.out.println("------------------");
			System.out.println("Cardinality: " + c);
			for(int i = 0; i < tries; ++i) {
				System.out.println(times[i][j]);
			}
		}

	}

}